'****************************************************************************
'GLT69_2.BAS Graphic application for use with a Toshiba T6963C (or compatible)
'graphic LCD controller connected to a Microchip(TM) PIC 16F877 microcontroller
'Version 1.1
'Written in MELabs PicBasicPro(TM) Ver 2.40
'GLUTIL.EXE Ver 1.3 is an Windows based interface that is used with GLSDEMO.BAS
'============================================================================
'This program uses the GLTLIB_2.BAS Graphic Library
'The Graphic Library contains and initializes all the variables used.
'
'================== NOT FOR COMMERICIAL USE =================================
'
'       Author: Ranjit Diol, COMPSys Date: April, 2001
'            (c) Copyright COMPSys, April 2001
'
'   DISCLAIMER: This file is being released as non-commericial
'   software. It is being provided "AS IS", neither the author, 
'   nor COMPSys shall be held liable for any damages caused
'   by its use.
' 
'   This product is issued as a single license and can not
'   be distributed to others without the explicit consent of
'   COMPSys.
' 
'   SINGLE USER LICENSE: This application may be used in its entirety or 
'   in parts within some other non-commercial application(s) as long
'   as the those applications are used solely by the licensee.
'
'
'        Contact: rsdiol@compsys1.com for more information
'===============================================================================
'clear all variables
Clear

DEFINE	ONINT_USED	1	'Required if using ISP
DEFINE OSC 20			'OSC speed, you may have to tweak the 'strobe'
				'routine's e_pause constant for other speeds
ADCON1	= 7			'Make all pins digital, you may adjust as needed


SPBRG=0				'************ NOTE ***********
RCSTA=0				'This is required if you are using
TXSTA=2				'Shane Tolmie's bootloader (PICLoader)
				'*****************************
'Temp variables used
tmp_x VAR BYTE
tmp_y VAR BYTE
tmp_x = 0
tmp_y = 0


m_edata	 VAR	BYTE		'Data byte to be written
m_edata     =     0

'Internal eeprom 
m_addr     VAR    BYTE
m_addr     =      $00
m_i        VAR    BYTE            'Index Counter

INCLUDE "gltlib_2.bas"		'The graphic subroutines


'============================
' **** Start Program ******
'============================


main:

'testing -- display some bytes
'test Graphic LCD
glcdinit:

	GoSub gl_init		'Initialize and clear display
	GoSub grf_on		'Graphics on

'*** READ FROM EXTERNAL EEPROM and then display
eep_addr = 0								'load page 1 of eeprom
For gl_y = 0 to 63
For gl_x = 0 to 239 step 8
I2CRead sda,scl,ctl,eep_addr,[gl_byte]
'serout2 out_pin,ser_baud,[HEX gl_byte]
GoSub put_byte
eep_addr = eep_addr + 1
Next gl_x
Next gl_y
glcd_ce = 1

Pause 7000 'wait a few seconds

'
'Now clear the display
GoSub grf_clr
GoSub grf_txt_on         '*****New added July 8


'testing -- display designs

	   glc_cx = 119			'Circle Center x
	   glc_cy = 31			'Circle Center y
	For glc_r = 10 to 30 step 10	'Radius
	   GoSub gl_circ
	Next glc_r

	   glc_cx = 45			'Square Center x
	   glc_cy = 31			'Square Center y
	For glc_r = 10 to 30 step 10	'Radius
	   GoSub gl_square
	Next glc_r

	   glc_cx = 194			'Square45 Center x
	   glc_cy = 31			'Square45 Center y
	For glc_r = 10 to 30 step 10	'Radius
	   GoSub gl_square45
	Next glc_r


Pause 2000 'wait a  sec or two

'Now clear the display
GoSub grf_clr
GoSub grf_txt_on        
gl_x = 8	'Horiz pos
gl_y = 8        'Vert pos
For gl_i = 0 to 26
  LookUp gl_i,["Sanyo 240x64 using a T6963C"],g_char
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i

Pause 2000 'wait a  sec


gl_x = 40	'Horiz pos
gl_y = 24       'Vert pos

For gl_i = 0 to 18
  LookUp gl_i,[" By COMPSys(c) 2002"],g_char  
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i

gl_y = 34
For gl_x = 48 to 200
	gl_y = 33
	GoSub gl_setdot
	gl_y = 35
	GoSub gl_setdot
Next gl_x

Pause 2000 'let's look at a while


'Reinitialize lcd
GoSub gl_init
GoSub grf_txt_on        
'****** NEW Test chart axis **********
'Set addr ptr
s_tick = 4	'Tick mark spacing
s_ystart = 10	'Start pos
s_yend = 50	'End pos
s_xstart = 10
s_xend = 120
GoSub gl_xaxis	'draw xaxis
GoSub gl_yaxis	'draw yaxis

'Next add some labels
gl_x = 32
gl_y = 0
For gl_i = 0 to 5
  LookUp gl_i,["SYSTEM"],g_char
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i


'Vertical
gl_x = 0	'First pos on line
gl_y = 16       '3rd line down line down
For gl_i = 0 to 3
  LookUp gl_i,["TEMP"],g_char
  GoSub put_char
  gl_y = gl_y + 8
Next gl_i

'Now Horiz at bottom
gl_x = 32	'Start a bit to the right
gl_y = 56        'Bottom line down
For gl_i = 0 to 5
  LookUp gl_i,["HOURLY"],g_char
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i

gl_y = s_yend - 1 
'Now set a bunch of dots 
 For gl_x = s_xstart to s_xend

    Random gl_inc1

          IF gl_inc1.BYTE0 > 127 Then
              gl_y = gl_y - 1
            Else
             gl_y = gl_y + 1
          EndIF

   IF gl_y > s_yend   Then  gl_y = s_yend-1 
   IF gl_y < s_ystart Then  gl_y = s_ystart + 1

 GoSub gl_setdot
 Next gl_x  

gl_x = 122
gl_y = 24
For gl_i = 0 to 12 
  LookUp gl_i,["Terminal Mode"],g_char
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i

gl_x = 120
gl_y = 32
For gl_i = 0 to 12 
  LookUp gl_i,["Waiting......"],g_char
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i

gl_x = 122
gl_y = 40
For gl_i = 0 to 13 
  LookUp gl_i,["Use GLUTIL 1.3"],g_char
  GoSub put_char
  gl_x = gl_x + 8
Next gl_i


'End of intro screen
'======================================

'*******************
'* BEGIN MAIN LOOP *
'*******************

'Main loop	  
get_char:
	  SerOut2 out_pin,ser_baud,["Ready:",10,13]
	  SerIn2 in_pin,ser_baud,[wait ("]"),in_dat] 	     'Wait for ] and the load in_dat
	      IF (in_dat="c") OR (in_dat = "C") Then do_circ     'Branch to circle sub ]c]40201e
	      IF (in_dat="s") OR (in_dat = "S") Then do_square   'Branch to square sub		
          IF (in_dat="q") OR (in_dat = "Q") Then do_sqr45    'Branch to square45 sub
          IF (in_dat="t") OR (in_dat = "T") Then do_star4    'Branch to star4 sub
          IF (in_dat="l") OR (in_dat = "L") Then do_line     'Branch to line sub
          IF (in_dat="r") OR (in_dat = "R") Then do_rect     'Branch to rect sub
          IF (in_dat="b") OR (in_dat = "B") Then do_bar      'Branch to bar sub
          IF (in_dat="k") OR (in_dat = "K") Then do_clear    'Branch to clear sub
	      IF (in_dat="d") OR (in_dat = "D") Then do_setdot   'Branch to setdot sub
	      IF (in_dat="e") OR (in_dat = "E") Then do_resetdot 'Branch to resetdot sub
          IF (in_dat="p") OR (in_dat = "P") Then do_putchar  'Branch to putchar sub
          IF (in_dat="u") OR (in_dat = "U") Then do_putbyte  'Branch to putbyte sub
          IF (in_dat="x") OR (in_dat = "X") Then do_xaxis    'Branch to x-axis sub
          IF (in_dat="y") OR (in_dat = "Y") Then do_yaxis    'Branch to y-axis sub
          IF (in_dat="f") OR (in_dat = "F") Then do_fill     'Branch to do_fill sub
          IF (in_dat="h") OR (in_dat = "H") Then do_hstring  'Branch to do_hstring sub
          IF (in_dat="v") OR (in_dat = "V") Then do_vstring  'Branch to do_vstring sub
          IF (in_dat="m") OR (in_dat = "M") Then do_lcd_w    'Branch to do_lcd_w sub
          IF (in_dat="n") OR (in_dat = "N") Then do_lcd_r    'Branch to do_lcd_r sub
          IF (in_dat="o") OR (in_dat = "O") Then do_eep_w    'Branch to do_eep_w sub
          IF (in_dat="a") OR (in_dat = "A") Then do_eep_r    'Branch to do_eep_r sub
          IF (in_dat="g") OR (in_dat = "G") Then do_ieep_r   'Branch to do_ieep_r sub
          IF (in_dat="w") OR (in_dat = "W") Then do_ieep_w   'Branch to do_ieep_w sub
		

GoTo get_char
' End of Terminal Loop


'Start of Routine Branches
'=========================
'CIRCLE
do_circ:
GoSub get_three		'Get 3 values
GoSub c_assign		'Assign the values
GoSub gl_circ		'Draw the circle
			'Return back to main loop
GoTo get_char		'Get next command


'SQUARE
do_square:
GoSub get_three		'Get 3 values
GoSub c_assign		'Assign the values
GoSub gl_square		'Draw the square
GoTo get_char		'Get next command

'SQUARE45
do_sqr45:
GoSub get_three		'Get 3 values
GoSub c_assign		'Assign the values
GoSub gl_square45	'Draw the diamond
GoTo get_char		'Get next command


'STAR4
do_star4:
GoSub get_three		'Get 3 values
GoSub c_assign		'Assign the values
GoSub gl_star4		'Draw the 4 point star
GoTo get_char		'Get next command

'BAR
do_bar:
   GoSub get_four
   GoSub get_tick
   GoSub gl_bar
GoTo get_char


'RECTANGLE
do_rect:
  GoSub get_four
  GoSub get_tick

'**** Modified 02/02/02 *****
  gosub get_two
  fill_flag = b_inp1
  clr_flag  = b_inp2
    if fill_flag = 1 then
        GoSub grf_clr_Rect
     else
        GoSub gl_rect
    endif
'****************************
GoTo get_char

'LINE
do_line:
GoSub get_four		'Get 4 values and assign them
    GoSub gl_line	'Draw the line
GoTo get_char

'X AXIS
do_xaxis:
  GoSub get_three
  s_xstart = b_inp1
  s_xend   = b_inp2
  s_ystart = b_inp3
  GoSub get_tick		'Get the tick mark value
  GoSub gl_xaxis		'Draw x-axis
GoTo get_char

'Y AXIS
do_yaxis:
  GoSub get_three
  s_ystart  = b_inp1
  s_yend    = b_inp2
  s_xstart  = b_inp3
  GoSub get_tick		'Get the tick mark value
  GoSub gl_yaxis		'Draw y-axis
GoTo get_char


'CLEAR LCD
do_clear:
  GoSub grf_clr
GoTo get_char

'RESET/SET DOT
'Set /Reset Dot routine
do_resetdot:		'Set flag and drop down to setdot sub
rs_flag = 1
do_setdot:
  GoSub get_two		'Get  values and assign them
  GoSub xy_assign
  GoSub gl_setdot       'Set the dot (pixel)
  rs_flag = 0
GoTo get_char

'PLACE CHARACTER
do_putchar:
  GoSub get_two
  GoSub xy_assign
  GoSub get_tick                          'Wait for ] and get gl_chr then load gl_char
  g_char = gl_chr
  GoSub put_char
  GoTo get_char

'PLACE BYTE
do_putbyte:
  GoSub get_three
  GoSub xy_assign
  gl_byte = b_inp3	'Byte to be placed
  GoSub put_byte	'Place it
GoTo get_char

do_fill:
GoSub get_tick		'Get the value for design

gl_x1 = 0
gl_x2 = 239
gl_y1 = 0
gl_y2 = 63
GoSub gl_bar
GoTo get_char


'Place a horizontal string using int eeprom character
do_hstring:
  GoSub get_two
  GoSub xy_assign
  GoSub gl_txt_pos
  tmp_x = gl_xpos
  GoSub get_tick           'Wait for ] and the load gl_chr

 While gl_chr <> "@"
       IF gl_chr =";" Then
             g_char = " "
             GoSub put_char
             GoTo skip_space
       EndIF
      g_char = gl_chr
      GoSub put_char
skip_space:
      gl_x = gl_x +8
      IF gl_x > 239 Then
         gl_xpos = tmp_x
      EndIF
      GoSub gl_txt_pos
      GoSub get_tick
  Wend
  
GoTo get_char


'Place a vertical string using int eeprom character
do_vstring:
  GoSub get_two
  GoSub xy_assign
  tmp_x = gl_x
  tmp_y = gl_y
  GoSub gl_txt_pos
  GoSub get_tick         'Wait for ] and the load gl_chr
  While gl_chr <> "@"
       IF gl_chr =";" Then
             g_char = " "
             GoSub put_char
             GoTo skip_vspace
       EndIF
      g_char = gl_chr
      GoSub put_char
skip_vspace:
      gl_x = tmp_x
      gl_y = gl_y + 8
      IF gl_y > 63 Then
         gl_y = tmp_y
      EndIF
      GoSub gl_txt_pos
      GoSub get_tick
  Wend

GoTo get_char

'Write int eeprom
do_ieep_w:
gl_flag = 2
GoTo eep_rw

'Read int eeprom
do_ieep_r:
gl_flag = 3
GoTo eep_rw:


'Write ext eeprom
do_eep_w:
gl_flag = 0
GoTo eep_rw

'Read ext eeprom
do_eep_r:
gl_flag = 1

eep_rw:

GoSub get_four					'Get 4 hex values
ee_addr1.BYTE1 = gl_x1				'Convert them to words
ee_addr1.BYTE0 = gl_x2
ee_addr2.BYTE1 = gl_y1
ee_addr2.BYTE0 = gl_y2

serout2 out_pin,ser_baud,[hex4 ee_addr1," ",hex4 ee_addr2] 'for debugging
 For ee_addr = ee_addr1 to ee_addr2
	'External Eeprom
	IF gl_flag = 0 Then
          GoSub get_one				     'Get byte from I/O
          I2CWrite sda,scl,ctl,ee_addr,[b_inp1]      'and send to ext eeprom
          Pause 10
	EndIF
        IF gl_flag = 1 Then
          I2CRead sda,scl,ctl,ee_addr,[gl_chr]       'or Read chr from ext eeprom
          GoSub send_one
        EndIF
 
	'Internal Eeprom
	IF gl_flag = 2 Then
          GoSub get_one				     'Get byte from I/O
          Write ee_addr.BYTE0,b_inp1                 'and send to int eeprom
          'pause 10
	EndIF
        IF gl_flag = 3 Then
          Read ee_addr.BYTE0,gl_chr                   'or Read chr from int eeprom
	  GoSub send_one                              'and send it out I/O          
        EndIF
 

Next ee_addr
 gl_flag = 0
GoTo get_char


   
'Read LCD data from the LCD at location x,y and send to I/O
do_lcd_r:
 GoSub get_four         'Get gl_x1,gl_x2, gl_y1 and gl_y2
  For gl_y = gl_y1 to gl_y2
    For gl_x = gl_x1 to gl_x2
	GoSub read_lcd                                'This returns gl_chr
      	GoSub send_one                              'and send it out I/O   
    Next gl_x
  Next gl_y
GoTo get_char


do_lcd_w:
  GoSub get_four         'Get gl_x1,gl_x2, gl_y1 and gl_y2 
  For gl_y = gl_y1 to gl_y2
    For gl_x = gl_x1 to gl_x2
	GoSub get_one		'Returns in b_inp1
	gl_byte = b_inp1
        GoSub put_byte	        'Place it
    Next gl_x
  Next gl_y
End

'Sample Image


'******************
'* END OF PROGRAM *
'******************
